function range2Index(range) {
    var startRange, endRange;
    if (range.collapsed) {
        startRange = range;
        endRange = range;
    } else {
        startRange = range.cloneRange();
        startRange.collapse(true);
        endRange = range;
        endRange.collapse(false);
    }

    var startOffset = 0;
    var startNode = startRange.startContainer;
    if (startNode.nodeType == 3) {
        startOffset = startRange.startOffset;
    } else {
        var textNode = document.createTextNode("");
        startRange.insertNode(textNode);
        startNode = textNode;
        startRange.setStart(textNode, 0);
        startRange.setEnd(textNode, 0);
    }

    var endOffset = 0;
    var endNode = endRange.endContainer;
    if (endNode.nodeType == 3) {
        endOffset = endRange.endOffset;
    } else {
        var textNode = document.createTextNode("");
        endRange.insertNode(textNode);
        endNode = textNode;
    }

    var iterator =
        document.createNodeIterator(document.body, NodeFilter.SHOW_TEXT,
            null, false);
    var node = iterator.nextNode();
    if (node) {
        var startIndex = 0;
        var endIndex = 0;
        var currentCharacter = 0;
        var foundStart = false;
        var foundEnd = false;
        while (node) {
            if (node == startNode) {
                startIndex = currentCharacter;
                foundStart = true;
                /*console.log('found start node: ' + startIndex + ' "' + node.nodeValue + '"');*/
            }
            if (node == endNode) {
                endIndex = currentCharacter;
                foundEnd = true;
                /*alert('found end node: ' + endIndex + ' "' + node.nodeValue + '"');*/
            }
            if (foundStart && foundEnd) {
                break;
            }
            currentCharacter += node.nodeValue.length;
            node = iterator.nextNode();
        }
        return (startIndex + startOffset);
    }
}