var forceImageId = "";
var forcePageNumber = 0;
var pageStartOffset = 0;
var pageImageOffset = "";
var orientationFactor = ###orientation_factor###;

var screen_height = ###full_screen_height###;
var screen_width = ###screen_width###;
var screen_padding = ###screen_margin###;

$(document).ready(function(event) {
    setClickOnHtml();
    overrideLinks();
    overrideImages();
});

$(window).bind("load", function() {
	prepareChapterLayout();
	prepareChapter()
});

$(window).resize(function() {
  if(forceImageId !== "") {
       jumpTo(0, forceImageId);
       js2java.savePage(-1);
   } else if(forcePageNumber > 0 ) {
       goToPage(forcePageNumber);
   } else if(pageImageOffset !== "") {
      jumpTo(0, pageImageOffset);
   } else {
       var page = getPageByOffset(pageStartOffset);
       js2java.savePage(page);
   }
});


function prepareChapter() {
    var pageHeaders = document.getElementsByClassName('page-header');
    var subChapterIds = [];
    var subChapterPageOffsets = [];
    for (var i = 0; i < pageHeaders.length; i++) {
        var pageHeader = pageHeaders[i];
        var nextElement = pageHeader.nextSibling;
        var position = $(nextElement).position();
        var offset = position.left - screen_padding;
        var pageOffset =  Math.ceil(offset/screen_width);
        subChapterIds.push(pageHeader.getAttribute('id'));
        subChapterPageOffsets.push(pageOffset);
    }
    var width = document.body.scrollWidth;
    var pageNumber = Math.ceil(width/screen_width);
    window.js2java.onChapterMeasured2(pageNumber, subChapterIds, subChapterPageOffsets);
}

function setClickOnHtml(bodyElement) {
    var htmlElement = document.getElementsByTagName('html')[0];
    htmlElement.onclick = function (event) {
        event.preventDefault();
        tapedHtml();
    };
}

function scrollToBegin() {
    window.scrollTo(0, 0);
}

function scrollToEnd() {
    window.scrollTo(document.body.scrollWidth, 0);
}

function tapedHtml() {
    js2java.bodyClicked();
}

function overrideImages() {
    var images = document.getElementsByTagName('img');
    for (var i = 0; i < images.length; i++) {
        var imageElement = images[i];
        if(imageElement.getAttribute('id') === null) {
            images[i].setAttribute("id", "democlass_" + i);
        }
        var parentElement = imageElement.parentNode;
        if(parentElement == null || parentElement.getAttribute('href') == null) {
            imageElement.onclick = function (event) {
                event.preventDefault();
                tapedImage(this);
                window.event.stopPropagation();
            };
        }
    }
}

function tapedImage(imageElement) {
    var imageSrc = imageElement.src;
    var imageId = imageElement.id;
    if (imageSrc != null) {
        js2java.imageClicked(imageId, imageSrc);
    }
}

function overrideLinks() {
    var links = document.getElementsByTagName('a');
    for (var i = 0; i < links.length; i++) {
        var linkElement = links[i];
        var hasHref = linkElement.getAttribute('href') != null;
        var isNoteref = (linkElement.getAttribute('epub:type') === 'noteref') || (linkElement.getAttribute('class') === 'noteref');
        if (hasHref && isNoteref) {
            linkElement.onclick = function (event) {
                event.preventDefault();
                tapedNoteref(this);
                window.event.stopPropagation();
            };
        } else {
            linkElement.onclick = function (event) {
                        event.preventDefault();
                        tapedLink(this);
                        window.event.stopPropagation();
                    };
        }
    }
}

function tapedNoteref(noterefElement) {
    js2java.noteLinkClicked(window.location.href, noterefElement.href);
}

function tapedLink(element) {
    js2java.linkClicked(element.getAttribute('href'));
}

function prepareChapterLayout() {
	var width = document.body.scrollWidth;
	var pageNumber = Math.ceil(width/screen_width);
	window.js2java.onChapterMeasured(pageNumber);
}

function prepareSubChapter() {
    var pageHeaders = document.getElementsByClassName('page-header');
    var subChapterIds = [];
    var subChapterPageOffsets = [];
    for (var i = 0; i < pageHeaders.length; i++) {
        var pageHeader = pageHeaders[i];
        var nextElement = pageHeader.nextSibling;
        var position = $(nextElement).position();
        var offset = position.left - screen_padding;
        var pageOffset =  Math.ceil(offset/screen_width);
        subChapterIds.push(pageHeader.getAttribute('id'));
        subChapterPageOffsets.push(pageOffset);
    }
    window.js2java.onHeadersFind(subChapterIds, subChapterPageOffsets);
}


/**
*	Tells java to scroll the html content to the place given by the element's id or the anchor name
*/
function jumpTo(from, href) {
    /*console.log("jumpTo from: "+from+" href: "+href);*/
    var anchor = findAnchor(href);
    var offset = anchor.offsetLeft;
    /*console.log("jumpTo anchor top: "+ offset+" left: "+anchor.offsetLeft);*/
    var fromPage = Math.floor(from / screen_width);
    var toPage = Math.floor(offset / screen_width);
    var diff = Math.round((offset-from)/screen_width);
    var divider = screen_width>screen_height ? orientationFactor : 1;
    /*console.log("jump to "+toPage + "/"+ divider);*/
    /*window.js2java.scrollToPage();*/
    window.scrollTo(screen_width*Math.floor(toPage/divider), 0);
    window.js2java.jsPageSet(screen_width*Math.floor(toPage/divider));
}

function goToPage(page){
    window.scrollTo(screen_width*page, 0);
    window.js2java.jsPageSet(screen_width*page);
}

/**
*	returns the element with id given by the tag param or the anchor of given name
*/
function findAnchor(tag) {
    var id = document.getElementById(tag);
    if (id !== null) {
        return id;
    }
    var links = document.getElementsByTagName('a');
    for (var i = 0; i < links.length; i++) {
        var name = links[i].getAttribute('name');
        if (name === tag)
            return links[i];
    }

     var images = document.getElementsByTagName('img');
        for (var i = 0; i < images.length; i++) {
            var name = images[i].getAttribute('id');
            if (name === tag)
                return images[i];
        }
}
/**
*Passes to java offsets of both start and end of current page
*/
function getOffsets() {
	var start = indexOfCharacterAtPosition(0, 0);
	if((typeof start) === 'string' && start.search('democlass') != -1) {
	    pageImageOffset = start;
	    window.js2java.setImageOffset(start);
	} else if((typeof start) === 'number'){
	    pageStartOffset = start;
    	var end = indexOfCharacterAtPosition(screen_width-1, screen_height-1);
    	if((typeof end) === 'number'){
    	     pageImageOffset = "";
	         window.js2java.setOffsets(start, end);
    	}
	}
}

/**
*returns number of the page containing given offset
*/
function getPageByOffset(offset){
	var position = positionOfCharacterAtIndex(offset, false);
	
	var page = Math.floor(position/screen_width);
	var x = page*screen_width;
	window.scrollTo(x, 0);
	window.js2java.jsPageSet(x);
	return page;
	/*window.js2java.scrollToPage(page);*/
}

function pageNumberByOffset(offset){
	var position = positionOfCharacterAtIndex(offset, false);
	var divider = screen_width>screen_height ? orientationFactor : 1;
	var width = screen_width/divider;
	var page = Math.floor(position/width);
	return page;
}

function changeStyles(textColor, font, fontSize, columnWidth, height, isTablet, colors){
	/*console.log('textColor: ' + textColor + ' font' + font + ' fontSize: ' + fontSize);*/
	var style = document.body.style;
 	style.setProperty('color', textColor, 'important');
	if(colors){return;}

	style.setProperty('font-family', font, 'important');
	var textSize = fontSize + '%';
	style.setProperty('font-size', textSize, 'important');
	style.setProperty('-webkit-column-width', columnWidth+'px', 'important');
	style.setProperty('height', height+'px', 'important');
	orientationFactor = isTablet ? 2 :1;
	prepareChapterLayout();
	getPageByOffset(pageStartOffset);
}

function setScreenDimensions(width, height) {
	console.log('setDimensions: ' + width + ' height' + height);
	screen_height = height;
	screen_width = width;
}

function reloadCss(imageId, offset, orientation, screenWidth, screenHeight, cssHeight, cssWidth) {
    forceImageId = imageId;
    forcePageNumber = offset;
    console.log('setDimensions: screenw ' + screenWidth + ' screen height' + screenHeight);
	screen_height = screenHeight;
	screen_width = screenWidth;
	orientationFactor = orientation;

	var style = document.body.style;
    style.setProperty('height', cssHeight + 'px', 'important');
    style.setProperty('-webkit-column-width', cssWidth + 'px', 'important');
}


function getBookmarkPages(param) {
	var result = getPageNumbersForOffsets(param);
	/*console.log("bookmarks: "+result);*/
	window.js2java.setBookmarkPages(result, false);
}

function getPageNumbersForOffsets(param){
		/*console.log('getBookmarkPages: '+param);*/
	var data = param.split('+');
	var length = data.length;
	var result = '';
	for(var i = 0; i<length;i++) {
		if(data[i] === null || data[i] === "")break;
		var obj = data[i].split('_');
		obj[1] = pageNumberByOffset(parseInt(obj[1]));
		data[i] = obj[0]+'_'+obj[1];
		result+=(data[i] + "@");
	}
	return result;
}