var forceImageId = "";
var forcePageNumber = 0;
var pageStartOffset = 0;
var pageImageOffset = "";

var screen_height = ###full_screen_height###;
var screen_width = ###screen_width###;
var screen_padding = ###screen_margin###;

$(document).ready(function(event) {
    setClickOnHtml();
    overrideLinks();
    overrideImages();
});

$(window).bind("load", function() {
	prepareChapterLayout();
});

$(window).resize(function() {
   if(forceImageId !== "") {
       jumpTo(0, forceImageId);
       js2java.savePage(-1);
   } else if(forcePageNumber > 0 ) {
       goToPage(forcePageNumber);
 } else if(pageImageOffset !== "") {
      jumpTo(0, pageImageOffset);
      /*js2java.savePage(-1);*/
   } else {
       var page = getPageByOffset(pageStartOffset);
       js2java.savePage(page);
   }
});

function setClickOnHtml(bodyElement) {
    var htmlElement = document.getElementsByTagName('html')[0];
    htmlElement.onclick = function (event) {
        event.preventDefault();
        tapedHtml();
    };
}

function prepareChapter() {
    var pageHeaders = document.getElementsByClassName('page-header');
    var subChapterIds = [];
    var subChapterPageOffsets = [];
    for (var i = 0; i < pageHeaders.length; i++) {
        var pageHeader = pageHeaders[i];
        var nextElement = pageHeader.nextSibling;
        var position = $(nextElement).position();
        var offset = position.top;
        var pageOffset =  Math.floor(offset/screen_height);
        subChapterIds.push(pageHeader.getAttribute('id'));
        subChapterPageOffsets.push(pageOffset);
    }

    var body = document.getElementsByTagName('body')[0];
	body.style.height = "";
	var height = body.scrollHeight;
	var pageNumber = Math.ceil(height / screen_height);
    	window.js2java.onChapterMeasured2(pageNumber, subChapterIds, subChapterPageOffsets);
}


function tapedHtml() {
    js2java.bodyClicked();
}

function overrideLinks() {
    var links = document.getElementsByTagName('a');
    for (var i = 0; i < links.length; i++) {
        var linkElement = links[i];
        var hasHref = linkElement.getAttribute('href') != null;
        var isNoteref = (linkElement.getAttribute('epub:type') === 'noteref') || (linkElement.getAttribute('class') === 'noteref');
        if (hasHref && isNoteref) {
            linkElement.onclick = function (event) {
                event.preventDefault();
                tapedNoteref(this);
                window.event.stopPropagation();
            };
        } else {
            linkElement.onclick = function (event) {
                        event.preventDefault();
                        tapedLink(this);
                        window.event.stopPropagation();
                    };
        }
    }
}

function tapedNoteref(noterefElement) {
    js2java.noteLinkClicked(window.location.href, noterefElement.href);
}

function tapedLink(element) {
    js2java.linkClicked(element.getAttribute('href'));
}

function overrideImages() {
    var images = document.getElementsByTagName('img');
    for (var i = 0; i < images.length; i++) {
        var imageElement = images[i];
            if(imageElement.getAttribute('id') === null) {
                    images[i].setAttribute("id", "democlass_" + i);
                }
        imageElement.onclick = function (event) {
            event.preventDefault();
            tapedImage(this);
            window.event.stopPropagation();
        };
    }
}


function reloadCss(imageId, offset, orientation, screenWidth, screenHeight, cssHeight, cssWidth) {
    forceImageId = imageId;
    forcePageNumber = offset;
    console.log('setDimensions: screenw ' + screenWidth + ' screen height' + screenHeight);
	screen_height = screenHeight;
	screen_width = screenWidth;
	orientationFactor = orientation;

	var style = document.body.style;
    style.setProperty('height', cssHeight + 'px', 'important');
}

function tapedImage(imageElement) {
    var imageSrc = imageElement.src;
    var imageId = imageElement.id;
    if (imageSrc != null) {
        js2java.imageClicked(imageId, imageSrc);
    }
}

function prepareChapterLayout() {
	var body = document.getElementsByTagName('body')[0];
	body.style.height = "";
	var height = body.scrollHeight;
	/*console.log("prepareChapterLayout: height: "+height+" screen_height: "+screen_height+" pages: "+ Math.ceil( height / screen_height));*/
	window.js2java.onChapterMeasured(Math.ceil( height / screen_height));
}

function prepareSubChapter() {
    var pageHeaders = document.getElementsByClassName('page-header');
    var subChapterIds = [];
    var subChapterPageOffsets = [];
    for (var i = 0; i < pageHeaders.length; i++) {
        var pageHeader = pageHeaders[i];
        var nextElement = pageHeader.nextSibling;
        var position = $(nextElement).position();
        var offset = position.top;
        var pageOffset =  Math.floor(offset/screen_height);
        subChapterIds.push(pageHeader.getAttribute('id'));
        subChapterPageOffsets.push(pageOffset);
    }
    window.js2java.onHeadersFind(subChapterIds, subChapterPageOffsets);
}

function goToPage(page){
    window.scrollTo(0, screen_height*page);
    window.js2java.jsPageSet(screen_height*page);
}

/**
*	adjusts the height of the html content to fit the multiple of the screen height
*/
function adjustHeight(height){
	/*console.log("adjust screenHeight: "+screen_height);*/
	var h = Math.ceil(height/screen_height)*screen_height;
	
	document.getElementsByTagName('body')[0].style.setProperty('height', (h-2*###top_margin###)+'px;');
}

function jumpTo(from, href) {
    /*console.log("jumpTo from: "+from+" href: "+href);*/
    var anchor = findAnchor(href);
    var offset = anchor.offsetTop;
    /*console.log("jumpTo anchor top: "+ offset+" left: "+anchor.offsetLeft);*/
    var fromPage = Math.floor(from / screen_height);
    var toPage = Math.floor(offset / screen_height);
    var diff = Math.round((offset-from)/screen_height);
    /*console.log("jumpTo: diff="+diff+" col_height="+screen_heightb);*/
   /* window.js2java.scrollToPlace(diff);*/
    var y = toPage*screen_height;
    window.scrollTo(0, y);
    window.js2java.jsPageSet(y);
}

/**
*	Tells java to scroll the html content to the element of given id or to the anchor of given name
*/
function jumpTo(href) {
    var anchor = findAnchor(href);
    var offset = anchor.offsetTop;
    /*console.log("jumpTo anchor top: "+ offset+" left: "+anchor.offsetLeft);
    window.js2java.scrollToPlace(offset);*/
    var page = Math.floor(offset/screen_height);
    var y = page*screen_height;
    window.scrollTo(0, y);
    window.js2java.jsPageSet(y);
}

function findAnchor(tag) {
	/*console.log('finding tag: '+tag);*/
    var id = document.getElementById(tag);
    if (id !== null) {
	/*console.log('id found: '+tag);*/
        return id;
    }
    var links = document.getElementsByTagName('a');
    for (var i = 0; i < links.length; i++) {
        var name = links[i].getAttribute('name');
        if (name === tag){
                /*console.log('link found: '+name);*/
		return links[i];
	}
    }
	/*console.log('could not find tag: '+tag);*/
}

/**
*Passes to java offsets of both start and end of current page
*/
function getOffsets() {
	var start = indexOfCharacterAtPosition(0, 0);
   if((typeof start) === 'string' && start.search('democlass') != -1) {
      pageImageOffset = start;
   	    window.js2java.setImageOffset(start);
  } else if((typeof start) === 'number'){
  	    pageStartOffset = start;
  	    pageImageOffset = "";
      	var end = indexOfCharacterAtPosition(screen_width-1, screen_height-1);
      	if((typeof end) === 'number'){
  	         window.js2java.setOffsets(start, end);
      	}
  	}
}

/**
*returns number of the page containing given offset
*/
function getPageByOffset(offset){
	var position = positionOfCharacterAtIndex(offset, true);
	
	var page = Math.floor(position/screen_height);
	/*console.log("getPageByOffset: page:"+page+" offset: "+offset);*/
	/*window.js2java.scrollToPage(page);*/

	var y = page*screen_height;
	window.scrollTo(0, y);
	window.js2java.jsPageSet(y);
	return page;
}

function pageNumberByOffset(offset){
	var position = positionOfCharacterAtIndex(offset, true);

	var page = Math.floor(position/screen_height);
	return page;
}

function changeStyles(textColor, font, fontSize, columnWidth, height, isTablet, colors){
	var style = document.body.style;
 	style.setProperty('color', textColor, 'important');
	if(colors)
		return;
	style.setProperty('font-family', font, 'important');
	var textSize = fontSize + '%';
	style.setProperty('font-size', textSize, 'important');

	prepareChapterLayout();
	getPageByOffset(pageStartOffset);
}

function setScreenDimensions(width, height){
	screen_height = height;
	screen_width = width;
}

function getBookmarkPages(param){
	var result = getPageNumbersForOffsets(param);
	/*console.log("bookmarks: "+result);*/
	window.js2java.setBookmarkPages(result, true);
}

function getPageNumbersForOffsets(param) {
	/*console.log('getBookmarkPages: '+ param);*/
	var data = param.split('+');
	var length = data.length;
	var result = '';
	for(var i = 0; i<length;i++){
		if(data[i] === null || data[i] === "")
		    break;
		var obj = data[i].split('_');
		obj[1] = pageNumberByOffset(parseInt(obj[1]));
		data[i] = obj[0]+'_'+obj[1];
		result+=(data[i] + "@");
	}
	return result;
}